"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var async_1 = __importDefault(require("async"));
var inquirer_1 = __importDefault(require("inquirer"));
var eval_1 = __importDefault(require("./eval"));
var promptMapping = {
    string: 'input',
    boolean: 'confirm'
};
function ask(prompts, data, done) {
    async_1.default.eachSeries(Object.keys(prompts), function (key, next) {
        promptFunction(data, key, prompts[key], next);
    }, done);
}
exports.default = ask;
function promptFunction(data, key, prompt, done) {
    if (prompt.when && !eval_1.default(prompt.when, data)) {
        return done();
    }
    var promptDefault = prompt.default;
    if (typeof prompt.default === 'function') {
        promptDefault = function () {
            return prompt.default.bind(this)(data);
        };
    }
    inquirer_1.default.prompt([{
            type: promptMapping[prompt.type] || prompt.type,
            name: key,
            message: prompt.message || prompt.label || key,
            default: promptDefault,
            choices: prompt.choices || [],
            validate: prompt.validate || (function () { return true; })
        }]).then(function (answers) {
        if (typeof answers[key] === 'string') {
            data[key] = answers[key].replace(/"/g, '\\"');
        }
        else {
            data[key] = answers[key];
        }
        done();
    }).catch(done);
}
