"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var semver_1 = __importDefault(require("semver"));
var chalk_1 = __importDefault(require("chalk"));
var path_1 = __importDefault(require("path"));
var fs_1 = __importDefault(require("fs"));
var getResult = function (url) {
    return axios_1.default.get(url).then(function (data) {
        return data.data;
    }).catch(function (e) { });
};
exports.getResult = getResult;
var checkRepoVersion = function (repoName) { return __awaiter(void 0, void 0, void 0, function () {
    var tag_name;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, getResult("https://api.github.com/repos/" + repoName + "/releases/latest")];
            case 1:
                tag_name = (_a.sent()).tag_name;
                return [2 /*return*/, tag_name];
        }
    });
}); };
exports.checkRepoVersion = checkRepoVersion;
var checkCurrentTemplateVersion = function (macros, isTypeScript, tmpPath) { return __awaiter(void 0, void 0, void 0, function () {
    var repoName, pkgPath, tmpPackageConfig, latestVersion;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                repoName = isTypeScript ? macros.templateRepo : macros.templateTSRepo;
                pkgPath = path_1.default.join(tmpPath, 'package.json');
                if (!fs_1.default.existsSync(pkgPath)) return [3 /*break*/, 2];
                tmpPackageConfig = require(pkgPath);
                return [4 /*yield*/, checkRepoVersion(repoName)];
            case 1:
                latestVersion = _a.sent();
                return [2 /*return*/, semver_1.default.lt(tmpPackageConfig.version, latestVersion)];
            case 2: return [2 /*return*/, true];
        }
    });
}); };
exports.checkCurrentTemplateVersion = checkCurrentTemplateVersion;
var getLocalVersion = function () {
    var packagePath = require.resolve('../../package.json');
    var packageConfig = require(packagePath);
    var localVersion = packageConfig.version;
    return localVersion;
};
exports.getLocalVersion = getLocalVersion;
var getLastVersion = function (repoName) { return __awaiter(void 0, void 0, void 0, function () {
    var latestVersion, res, e_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                latestVersion = '';
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                return [4 /*yield*/, getResult("https://registry.npmjs.org/" + repoName)];
            case 2:
                res = _a.sent();
                latestVersion = res['dist-tags'].latest;
                return [3 /*break*/, 4];
            case 3:
                e_1 = _a.sent();
                return [3 /*break*/, 4];
            case 4: return [2 /*return*/, latestVersion];
        }
    });
}); };
exports.getLastVersion = getLastVersion;
var generatorSymbol = function (count, symbol) {
    if (symbol === void 0) { symbol = '*'; }
    var starSymbol = '';
    for (var i = 0; i < count; i++) {
        starSymbol += symbol;
    }
    return starSymbol;
};
exports.generatorSymbol = generatorSymbol;
var generatorPlace = function (origin, replace, longLength) {
    var index = Math.round(origin.length / 2) - Math.round(longLength / 2) - 1;
    var length = replace.length;
    var originArray = origin.split('');
    var replaceArray = replace.split('');
    for (var i = 0; i < length; i++) {
        originArray[i + index] = replaceArray[i];
    }
    return originArray.join('');
};
var generatorPrompt = function (_a) {
    var latestVersion = _a.latestVersion, localVersion = _a.localVersion, repoName = _a.repoName;
    var placeholder = "*" + generatorSymbol(53, ' ') + "*";
    var origin = "*" + generatorSymbol(63, ' ') + "*";
    var latest = 'latest:    ' + chalk_1.default.green(latestVersion);
    var installed = 'installed: ' + chalk_1.default.red(localVersion);
    var longLength = latest.length > installed.length ? latest.length : installed.length;
    console.log(generatorSymbol(55));
    console.log(placeholder);
    console.log('*', chalk_1.default.yellow(" A newer version of " + repoName + " is available. "), '*');
    console.log(placeholder);
    console.log(generatorPlace(origin, latest, longLength));
    console.log(generatorPlace(origin, installed, longLength));
    console.log(placeholder);
    console.log(generatorSymbol(55));
};
exports.generatorPrompt = generatorPrompt;
var checkCurrentRepoVersion = function (repoName) { return __awaiter(void 0, void 0, void 0, function () {
    var latestVersion, localVersion, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, getLastVersion(repoName)];
            case 1:
                latestVersion = _a.sent();
                if (!latestVersion)
                    return [2 /*return*/];
                localVersion = getLocalVersion();
                if (semver_1.default.lt(localVersion, latestVersion)) {
                    generatorPrompt({
                        localVersion: localVersion,
                        latestVersion: latestVersion,
                        repoName: repoName
                    });
                    return [2 /*return*/, true];
                }
                else {
                    return [2 /*return*/, false];
                }
                return [3 /*break*/, 3];
            case 2:
                err_1 = _a.sent();
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.checkCurrentRepoVersion = checkCurrentRepoVersion;
