"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var yargs_1 = __importDefault(require("yargs"));
var chalk_1 = __importDefault(require("chalk"));
var create_1 = __importDefault(require("./create"));
var macros_1 = __importDefault(require("./utils/macros"));
function run(args) {
    var scriptName = macros_1.default.scriptName, placeholder = macros_1.default.placeholder;
    yargs_1.default
        .scriptName(macros_1.default.scriptName)
        .usage("$0 <" + macros_1.default.placeholder + "> [options]", "创建 remax 项目", function (yargs) {
        return yargs.positional(macros_1.default.placeholder, {
            describe: '项目目录',
            type: 'string'
        });
    }, function (argv) {
        create_1.default(argv, macros_1.default);
    })
        .option('h', {
        alias: 'help'
    })
        .option('v', {
        alias: 'version'
    })
        .option('t', {
        alias: 'typescript',
        default: false,
        describe: 'create remax typescript app',
        type: 'boolean'
    })
        .option('c', {
        alias: 'check',
        default: true,
        describe: 'ignore version check',
        type: 'boolean'
    })
        .fail(function (msg, err) {
        if (err)
            throw err;
        console.error('Please specify the project directory:');
        console.error('  ', chalk_1.default.blue(scriptName), chalk_1.default.green("<" + placeholder + ">"));
        console.error('\t');
        console.error('For example:');
        console.error('  ', chalk_1.default.blue(scriptName), chalk_1.default.green('first-remax-app'));
        console.error('\t');
        console.error('Run', chalk_1.default.blue(scriptName + " --help"), 'to see all options.');
        process.exit(1);
    })
        .parse(args);
}
exports.run = run;
